/**
 * Created by liz on 2015/6/5.
 */
/**
 * Created by wh on 2014/12/5.
 */
var co = require('co');
var mysql = require('@gopalroy/mysql-pool');

var TrackReplayAPI = (function(){
    function TrackReplayAPI(){
        this._pool = mysql.pool;
    }

    //获取组织下所有的车牌号
    TrackReplayAPI.prototype.getOrgLicense = function*(orgid){
        var sql = "select obd_code,license from t_car where s4_id = ? and license is not null and license != '' and act_type = 1;";
        return  yield this._pool.queryP(sql,orgid);
    };

    //获取组织下面一辆车某段时间内的轨迹记录
    TrackReplayAPI.prototype.getTracks = function*(obdcode,starttime,endtime){
        var sql = "select\t"+
                  "tripId,substr(t.longitude,2) as lng, substr(t.latitude,2) as lat,t.locationSpeed as speed,t.locationTime\t"+
                  //"TIMESTAMPDIFF(SECOND,t.locationTime,(select locationTime from t_obd_location where locationTime > t.locationTime and obdCode = ? order by locationTime asc limit 1)) * 1000 as minustime\t"+
                  "from\t"+
                  "t_obd_location as t\t"+
                  "where\t"+
                  "t.obdCode = ?\t"+
                  "and date_add(t.locationTime, interval 8 hour) between ? and ?\t"+
                  "order by t.locationTime asc;"
        return  yield this._pool.queryP(sql,[obdcode,starttime,endtime]);
    }

    return TrackReplayAPI;
})();

module.exports = {
    Core: TrackReplayAPI,

    // 获取组织下面的车牌号
    getOrgLicense: function(req, res){
        co(function*(){
            var orgId = req.params["orgid"];
            var API = new TrackReplayAPI();
            var reData = yield API.getOrgLicense(orgId);
            res.json({status:"success",license:reData});
        }).catch(function(ex){
             debug(ex.stack);
             res.status(500).send(ex.stack);
         });
    },
    getTracks:function(req,res){
        co(function*(){
            var orgId = req.params["orgid"];
            var obdCode = req.params["obdcode"];
            var startTime = req.query['starttime'];
            var endTime = req.query['endtime'];
            var API = new TrackReplayAPI();
            var reData = yield API.getTracks(obdCode,startTime,endTime);
            res.json({status:"success",tracks:reData});
        }).catch(function(ex){
            debug(ex.stack);
            res.status(500).send(ex.stack);
        });
    }
};
