/**
 * Created by liz on 2015/6/3.
 */
"use strict";

requirejs.config({
    paths:{
        angular:"/mscripts/angular.min",
        jquery:'/js/jquery.min',
        angularResource: "/mscripts/angular-resource.min",
        text:"/mscripts/text.min",
        bootstrap:'/js/bootstrap.min',
        datetimepicker:'/js/bootstrap-datetimepicker2.min'
    },
    shim:{
        jquery: { exports: '$' },
        angular: { exports: 'angular',deps:['jquery']},
        angularResource: ['angular'],
        bootstrap:['jquery'],
        datetimepicker:['bootstrap']
    }
});

requirejs(['angular', 'angularResource','jquery', './icBaiduTrack','./publicService','bootstrap','datetimepicker'], function(angular){
    angular.module('trackApp', ['trackreplay', 'ngResource'])
        .controller('trackCtrl', function($scope, $resource, publicService, $timeout){
            var apiLicense = $resource('./api/:orgid/getLicense', null, { 'get': { isArray:false}});
            var apiTrack = $resource('./api/:orgid/getTracks/:obdcode');
            //var apiRec = $resource('./api/:uoid/records', null, { 'get': { isArray:true} });
            //var apiStat = $resource('./api/:uoid/record/:tid/stat');
            //var apiSwitch = $resource('./api/:uoid/switch');
            //var apiSearch = $resource('./api/:soid/4Sinfo',null, { 'get': { isArray:true} });

            //初始化数据
            $scope.oper = {speed:10}; //定义操作按钮的
            $scope.licenseList = [{obd_code:"0",license:"请选择"}];
            $scope.chooseLicense = "0";
            $scope.scaleList = [{name:"请选择",id:1},{name:"20倍",id:20},{name:"30倍",id:30},{name:"40倍",id:40},{name:"50倍",id:50},{name:"100倍",id:100}];
            $scope.chooseScale = 1;

            //从url里面获取当前组织ID
            publicService.getOrgId(function(data){
                $scope.orgId = data.orgId;
                getOrgLicense(data.orgId);
            });

            //获取所有的车牌号
            function getOrgLicense(orgId){
                apiLicense.get({orgid:orgId},function(data){
                    Array.prototype.push.apply($scope.licenseList, data.license);
                    publicService.changeDatePicker("datetime",["datepicker_S","datepicker_E"]); //日期控件加载
                },function(ex){
                   if(ex.status === 500){
                       alert("连接超时，请稍后再试。");
                   }else if(ex.status === 403 || ex.status === 401){
                       alert("权限不足！");
                   }
                });
            }

            //搜索轨迹列表
            $scope.searchTrack = function(){
                //判断搜索条件是否成立
                if($scope.chooseLicense === "0"){
                    alert("请选择要查询的车牌号！");
                }else if($scope.startTime === "" || $scope.startTime === "undefined"){
                    alert("请填写开始时间！");
                }else if($scope.endTime === "" || $scope.endTime === "undefined"){
                    alert("请填写结束时间！");
                }else if($scope.startTime >= $scope.endTime){
                    alert("开始时间必须小于结束时间！");
                }else{
                    //$scope.chooseLicense= "20150128landu01";
                    //$scope.startTime = "2015-04-29 09:30";
                    //$scope.endTime = "2015-04-30 09:30";
                   var days = getDaysDiff($scope.startTime,$scope.endTime);
                    if(days>=-2){
                        apiTrack.get({orgid:$scope.orgId,obdcode:$scope.chooseLicense,starttime:$scope.startTime,endtime:$scope.endTime},function(data){
                            $scope.tracks = data.tracks;
                            for(var i=0;i< $scope.tracks.length;i++){
                                if(i < $scope.tracks.length-1 && $scope.tracks[i].tripId === $scope.tracks[i+1].tripId)
                                {
                                    $scope.tracks[i].minustime = getSecondsDiff($scope.tracks[i].locationTime,$scope.tracks[i+1].locationTime);
                                }else{
                                    $scope.tracks[i].minustime = 0;
                                }
                            }
                            if($scope.tracks.length === 0 ){
                                alert("该时间段无行驶记录！");
                            }
                        },function(ex){
                            if(ex.status === 500){
                                alert("连接超时，请稍后再试。");
                            }else if(ex.status === 403 || ex.status === 401){
                                alert("权限不足！");
                            }
                        })
                    }else{
                      alert("请查询两日以内的轨迹！");
                    }
                }

                //TODO  判断开始时间和结束时间间隔不得大于两天
            }

            //播放
            $scope.play = function(){
                $scope.oper.play = true;
                $scope.oper.pause = false;
                $scope.oper.reset = false;
            }


            //暂停
            $scope.pause = function(){
                $scope.oper.pause = true;
                $scope.oper.play = false;
                $scope.oper.reset = false;
            }

            //重置
            $scope.reset = function(){
                $scope.oper.reset = true;
                $scope.oper.play = false;
                $scope.oper.pause = false;
            }

            //选择倍速
            $scope.changeScale = function(){
                $scope.oper.speed = $scope.chooseScale;
            }


            //获取两个时间的时间差
            function getSecondsDiff(startTime,endTime){
                var date1=new Date(startTime);  //开始时间
                var date2=new Date(endTime);    //结束时间
                var date3=date2.getTime()-date1.getTime();  //时间差的毫秒数
                var seconds=Math.round(date3);
                return seconds;
            }

            //获取天数差
            function getDaysDiff(startTime,endTime){
                var startT = new Date(startTime).getTime();
                var endT = new Date(endTime).getTime();
                var grapT = startT - endT;
                var days=Math.floor(grapT/(24*3600*1000));
                return days;
            }
        });
    angular.bootstrap(document, ['trackApp']);
});